local RL1 = function(self)
	self:blend('BlendMode_Add')
	self:zoomx(.8)
	self:zoomy(1)
	self:diffusealpha(.5)
	self:decelerate(.1)
	self:zoomx(.5)
	self:zoomy(.2)
	self:diffusealpha(.1)
	self:decelerate(.02)
	self:diffusealpha(0)
end

local pn = Var "Player"

local sButton = Var "Button"

local Reverse = string.find(GAMESTATE:GetPlayerState(pn):GetPlayerOptionsString("ModsLevel_Preferred"), "Reverse")

local Notefield = 
{
	--dance/solo
	Up = {0,0},
	Down = {0,0},
	Left = {1,-32-8},
	Right = {1,32+8},
	UpLeft = {0,0},
	UpRight = {0,0},
	--kb7
	Key1 = {1,-32-8},
	Key2 = {0,0},
	Key3 = {0,0},
	Key4 = {0,0},
	Key5 = {0,0},
	Key6 = {0,0},
	Key7 = {1,32+8},
};


return Def.ActorFrame{
	OnCommand=function(self)
		local getc = SCREENMAN:GetTopScreen():GetChild("Player"..ToEnumShortString(pn)):GetChild("NoteField"):get_column_actors()
		for i2 in pairs(getc) do
			if i2 < 4 then
				getc[i2]:x(0)
			elseif i2 > 4 then
				getc[i2]:x(0)
			else
				getc[i2]:x(0)
			end
		end
	
		if not Reverse then
			self:zoomy(-1)
		end
	end;
	LoadActor(NOTESKIN:GetPath("_Bar","Notefield Side"))..{
		InitCommand=function(self)
			self:zoomy(9999)
			self:diffusealpha(Notefield[sButton][1])
			self:x(Notefield[sButton][2])
		end;
	};
	LoadActor(NOTESKIN:GetPath("_Bar","Notefield Center"))..{
		InitCommand=function(self) self:zoomy(9999) end;
	};
	
	LoadActor(NOTESKIN:GetPath("_Bar","Receptor Light2"))..{
		InitCommand=function(self) 
			self:vertalign(top)
			self:addy(-360)
			self:diffusealpha(0)
		end;
		W3Command=RL1;
		W2Command=RL1;
		W1Command=RL1;
	};
	LoadActor(NOTESKIN:GetPath("_Bar","Receptor Light1"))..{
		InitCommand=function(self) 
			self:vertalign(bottom)
			self:addy(45)
			self:diffusealpha(0)
		end;
		PressCommand=function(self) 
			self:blend('BlendMode_Add')
			self:diffusealpha(.7)
			self:sleep(.1)
		end;
		LiftCommand=function(self) self:blend('BlendMode_Add') self:diffusealpha(0) end;
	};
	LoadActor(NOTESKIN:GetPath("_Bar","Receptor Center"));
	LoadActor(NOTESKIN:GetPath("_Bar","Receptor Top"))..{
		InitCommand=function(self) self:addy(32) self:diffusealpha(1) end;
		PressCommand=function(self)
			self:finishtweening()
			self:addy(-32)
			self:decelerate(.2)
		end;
		LiftCommand=function(self) self:decelerate(.2) self:addy(32) end;
	};
	LoadActor(NOTESKIN:GetPath("_Bar","Receptor Back2"))..{
		InitCommand=function(self) self:addy(45) self:diffusealpha(1) end;
	};
	LoadActor(NOTESKIN:GetPath("_Bar","Receptor Back1"))..{
		InitCommand=function(self) self:addy(45) self:diffusealpha(1) end;
		PressCommand=function(self) self:diffusealpha(0) end;
		LiftCommand=function(self) self:diffusealpha(1) end;
	};
};